#include <kdialog.h>
#include <tdelocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'firewallsproxies.ui'
**
** Created by: The TQt user interface compiler (TQt 3.5.0)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "firewallsproxies.h"

#include <ntqvariant.h>
#include <ntqpushbutton.h>
#include <ntqtabwidget.h>
#include <ntqwidget.h>
#include <ntqcheckbox.h>
#include <ntqlabel.h>
#include <ntqgroupbox.h>
#include <ntqspinbox.h>
#include <ntqlineedit.h>
#include <ntqheader.h>
#include <ntqlistview.h>
#include <ntqlayout.h>
#include <ntqtooltip.h>
#include <ntqwhatsthis.h>
#include "firewallsproxies.ui.h"

/*
 *  Constructs a FirewallsProxies as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The qdialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal qdialog.
 */
FirewallsProxies::FirewallsProxies( TQWidget* parent, const char* name, bool modal, WFlags fl )
    : TQDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "FirewallsProxies" );
    setSizePolicy( TQSizePolicy( (TQSizePolicy::SizeType)7, (TQSizePolicy::SizeType)7, 0, 0, sizePolicy().hasHeightForWidth() ) );
    setSizeGripEnabled( TRUE );
    FirewallsProxiesLayout = new TQGridLayout( this, 1, 1, 11, 6, "FirewallsProxiesLayout"); 

    tabWidget = new TQTabWidget( this, "tabWidget" );

    TabPage = new TQWidget( tabWidget, "TabPage" );
    TabPageLayout = new TQGridLayout( TabPage, 1, 1, 11, 6, "TabPageLayout"); 

    kcfg_UseBridges = new TQCheckBox( TabPage, "kcfg_UseBridges" );

    TabPageLayout->addMultiCellWidget( kcfg_UseBridges, 0, 0, 0, 1 );
    spacer1 = new TQSpacerItem( 20, 80, TQSizePolicy::Minimum, TQSizePolicy::Expanding );
    TabPageLayout->addItem( spacer1, 4, 0 );

    pushButton3 = new TQPushButton( TabPage, "pushButton3" );

    TabPageLayout->addWidget( pushButton3, 2, 1 );

    textLabel1 = new TQLabel( TabPage, "textLabel1" );

    TabPageLayout->addWidget( textLabel1, 2, 0 );

    textLabel2 = new TQLabel( TabPage, "textLabel2" );
    textLabel2->setAlignment( int( TQLabel::WordBreak | TQLabel::AlignVCenter ) );

    TabPageLayout->addWidget( textLabel2, 3, 0 );

    BridgePanel = new TQGroupBox( TabPage, "BridgePanel" );
    BridgePanel->setEnabled( TRUE );
    BridgePanel->setSizePolicy( TQSizePolicy( (TQSizePolicy::SizeType)1, (TQSizePolicy::SizeType)3, 0, 0, BridgePanel->sizePolicy().hasHeightForWidth() ) );

    pushBridgeAdd = new TQPushButton( BridgePanel, "pushBridgeAdd" );
    pushBridgeAdd->setGeometry( TQRect( 462, 191, 72, 23 ) );

    BridgePort = new TQSpinBox( BridgePanel, "BridgePort" );
    BridgePort->setGeometry( TQRect( 296, 192, 57, 21 ) );
    BridgePort->setMaxValue( 65535 );

    FirewallLabel_2 = new TQLabel( BridgePanel, "FirewallLabel_2" );
    FirewallLabel_2->setGeometry( TQRect( 11, 31, 177, 150 ) );
    FirewallLabel_2->setSizePolicy( TQSizePolicy( (TQSizePolicy::SizeType)3, (TQSizePolicy::SizeType)4, 0, 0, FirewallLabel_2->sizePolicy().hasHeightForWidth() ) );

    BridgeAddress = new TQLineEdit( BridgePanel, "BridgeAddress" );
    BridgeAddress->setGeometry( TQRect( 194, 192, 95, 21 ) );

    BridgeKey = new TQLineEdit( BridgePanel, "BridgeKey" );
    BridgeKey->setGeometry( TQRect( 360, 192, 95, 21 ) );

    Bridge = new TQListView( BridgePanel, "Bridge" );
    Bridge->addColumn( tr2i18n( "Address" ) );
    Bridge->addColumn( tr2i18n( "Port" ) );
    Bridge->addColumn( tr2i18n( "Key (Optional)" ) );
    Bridge->setGeometry( TQRect( 194, 20, 340, 165 ) );
    Bridge->setSizePolicy( TQSizePolicy( (TQSizePolicy::SizeType)3, (TQSizePolicy::SizeType)3, 0, 0, Bridge->sizePolicy().hasHeightForWidth() ) );
    Bridge->setSelectionMode( TQListView::Extended );
    Bridge->setAllColumnsShowFocus( TRUE );
    Bridge->setResizeMode( TQListView::AllColumns );

    TabPageLayout->addMultiCellWidget( BridgePanel, 1, 1, 0, 1 );
    tabWidget->insertTab( TabPage, TQString::fromLatin1("") );

    Widget8 = new TQWidget( tabWidget, "Widget8" );
    Widget8Layout = new TQGridLayout( Widget8, 1, 1, 11, 6, "Widget8Layout"); 

    kcfg_FascistFirewall = new TQCheckBox( Widget8, "kcfg_FascistFirewall" );

    Widget8Layout->addWidget( kcfg_FascistFirewall, 0, 0 );

    Proxies = new TQGroupBox( Widget8, "Proxies" );
    Proxies->setEnabled( FALSE );
    Proxies->setColumnLayout(0, TQt::Vertical );
    Proxies->layout()->setSpacing( 6 );
    Proxies->layout()->setMargin( 11 );
    ProxiesLayout = new TQGridLayout( Proxies->layout() );
    ProxiesLayout->setAlignment( TQt::AlignTop );

    kcfg_HttpProxyAuthenticatorUserName = new TQLineEdit( Proxies, "kcfg_HttpProxyAuthenticatorUserName" );

    ProxiesLayout->addWidget( kcfg_HttpProxyAuthenticatorUserName, 1, 1 );

    textLabel3_2 = new TQLabel( Proxies, "textLabel3_2" );

    ProxiesLayout->addWidget( textLabel3_2, 0, 2 );

    kcfg_HttpsProxyAuthenticatorPassword = new TQLineEdit( Proxies, "kcfg_HttpsProxyAuthenticatorPassword" );

    ProxiesLayout->addWidget( kcfg_HttpsProxyAuthenticatorPassword, 4, 3 );

    textLabel2_4_3_2 = new TQLabel( Proxies, "textLabel2_4_3_2" );

    ProxiesLayout->addWidget( textLabel2_4_3_2, 4, 0 );

    kcfg_HttpsProxyPort = new TQSpinBox( Proxies, "kcfg_HttpsProxyPort" );
    kcfg_HttpsProxyPort->setMaxValue( 65535 );

    ProxiesLayout->addWidget( kcfg_HttpsProxyPort, 3, 3 );

    kcfg_HttpsProxyHost = new TQLineEdit( Proxies, "kcfg_HttpsProxyHost" );

    ProxiesLayout->addWidget( kcfg_HttpsProxyHost, 3, 1 );

    kcfg_HttpProxyAuthenticatorPassword = new TQLineEdit( Proxies, "kcfg_HttpProxyAuthenticatorPassword" );

    ProxiesLayout->addWidget( kcfg_HttpProxyAuthenticatorPassword, 1, 3 );

    textLabel1_3 = new TQLabel( Proxies, "textLabel1_3" );

    ProxiesLayout->addMultiCellWidget( textLabel1_3, 2, 2, 0, 1 );

    textLabel2_4_2_2_2 = new TQLabel( Proxies, "textLabel2_4_2_2_2" );

    ProxiesLayout->addWidget( textLabel2_4_2_2_2, 4, 2 );

    textLabel3_3_2 = new TQLabel( Proxies, "textLabel3_3_2" );

    ProxiesLayout->addWidget( textLabel3_3_2, 3, 2 );

    kcfg_HttpsProxyAuthenticatorUserName = new TQLineEdit( Proxies, "kcfg_HttpsProxyAuthenticatorUserName" );

    ProxiesLayout->addWidget( kcfg_HttpsProxyAuthenticatorUserName, 4, 1 );

    textLabel2_3_2 = new TQLabel( Proxies, "textLabel2_3_2" );

    ProxiesLayout->addWidget( textLabel2_3_2, 3, 0 );

    textLabel2_4_2_3 = new TQLabel( Proxies, "textLabel2_4_2_3" );

    ProxiesLayout->addWidget( textLabel2_4_2_3, 1, 2 );

    kcfg_HttpProxyHost = new TQLineEdit( Proxies, "kcfg_HttpProxyHost" );

    ProxiesLayout->addWidget( kcfg_HttpProxyHost, 0, 1 );

    kcfg_HttpProxyPort = new TQSpinBox( Proxies, "kcfg_HttpProxyPort" );
    kcfg_HttpProxyPort->setMaxValue( 65535 );

    ProxiesLayout->addWidget( kcfg_HttpProxyPort, 0, 3 );

    textLabel2_2 = new TQLabel( Proxies, "textLabel2_2" );

    ProxiesLayout->addWidget( textLabel2_2, 0, 0 );

    textLabel2_4_4 = new TQLabel( Proxies, "textLabel2_4_4" );

    ProxiesLayout->addWidget( textLabel2_4_4, 1, 0 );

    Widget8Layout->addWidget( Proxies, 3, 0 );

    kcfg_UseProxy = new TQCheckBox( Widget8, "kcfg_UseProxy" );

    Widget8Layout->addWidget( kcfg_UseProxy, 2, 0 );

    Firewall = new TQGroupBox( Widget8, "Firewall" );
    Firewall->setEnabled( FALSE );
    Firewall->setSizePolicy( TQSizePolicy( (TQSizePolicy::SizeType)1, (TQSizePolicy::SizeType)3, 0, 0, Firewall->sizePolicy().hasHeightForWidth() ) );
    Firewall->setColumnLayout(0, TQt::Vertical );
    Firewall->layout()->setSpacing( 6 );
    Firewall->layout()->setMargin( 11 );
    FirewallLayout = new TQGridLayout( Firewall->layout() );
    FirewallLayout->setAlignment( TQt::AlignTop );

    FirewallLabel2 = new TQLabel( Firewall, "FirewallLabel2" );

    FirewallLayout->addWidget( FirewallLabel2, 2, 0 );

    ReachableAddresses = new TQListView( Firewall, "ReachableAddresses" );
    ReachableAddresses->addColumn( tr2i18n( "Port" ) );
    ReachableAddresses->setSizePolicy( TQSizePolicy( (TQSizePolicy::SizeType)0, (TQSizePolicy::SizeType)3, 0, 0, ReachableAddresses->sizePolicy().hasHeightForWidth() ) );
    ReachableAddresses->setSelectionMode( TQListView::Extended );
    ReachableAddresses->setAllColumnsShowFocus( TRUE );
    ReachableAddresses->setResizeMode( TQListView::AllColumns );

    FirewallLayout->addWidget( ReachableAddresses, 0, 1 );

    kcfg_KeepalivePeriod = new TQSpinBox( Firewall, "kcfg_KeepalivePeriod" );
    kcfg_KeepalivePeriod->setMaxValue( 9999 );

    FirewallLayout->addWidget( kcfg_KeepalivePeriod, 2, 1 );

    pushAdd = new TQPushButton( Firewall, "pushAdd" );

    FirewallLayout->addWidget( pushAdd, 1, 2 );

    Port = new TQSpinBox( Firewall, "Port" );
    Port->setMaxValue( 65535 );

    FirewallLayout->addWidget( Port, 1, 1 );

    FirewallLabel = new TQLabel( Firewall, "FirewallLabel" );
    FirewallLabel->setSizePolicy( TQSizePolicy( (TQSizePolicy::SizeType)3, (TQSizePolicy::SizeType)4, 0, 0, FirewallLabel->sizePolicy().hasHeightForWidth() ) );

    FirewallLayout->addWidget( FirewallLabel, 0, 0 );

    Widget8Layout->addWidget( Firewall, 1, 0 );
    tabWidget->insertTab( Widget8, TQString::fromLatin1("") );

    FirewallsProxiesLayout->addWidget( tabWidget, 0, 0 );
    languageChange();
    resize( TQSize(582, 539).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( pushAdd, TQ_SIGNAL( clicked() ), this, TQ_SLOT( pushAdd_clicked() ) );
    connect( ReachableAddresses, TQ_SIGNAL( contextMenuRequested(TQListViewItem*,const TQPoint&,int) ), this, TQ_SLOT( ReachableAddresses_contextMenuRequested(TQListViewItem*,const TQPoint&,int) ) );
    connect( kcfg_FascistFirewall, TQ_SIGNAL( toggled(bool) ), this, TQ_SLOT( kcfg_FascistFirewall_toggled(bool) ) );
    connect( kcfg_UseProxy, TQ_SIGNAL( toggled(bool) ), this, TQ_SLOT( kcfg_UseProxy_toggled(bool) ) );
    connect( kcfg_HttpProxyHost, TQ_SIGNAL( textChanged(const TQString&) ), this, TQ_SLOT( kcfg_HttpProxyHost_textChanged(const TQString&) ) );
    connect( kcfg_HttpProxyAuthenticatorUserName, TQ_SIGNAL( textChanged(const TQString&) ), this, TQ_SLOT( kcfg_HttpProxyAuthenticatorUserName_textChanged(const TQString&) ) );
    connect( kcfg_HttpProxyAuthenticatorPassword, TQ_SIGNAL( textChanged(const TQString&) ), this, TQ_SLOT( kcfg_HttpProxyAuthenticatorPassword_textChanged(const TQString&) ) );
    connect( kcfg_HttpProxyPort, TQ_SIGNAL( valueChanged(int) ), this, TQ_SLOT( kcfg_HttpProxyPort_valueChanged(int) ) );
    connect( pushBridgeAdd, TQ_SIGNAL( clicked() ), this, TQ_SLOT( pushBridgeAdd_clicked() ) );
    connect( kcfg_UseBridges, TQ_SIGNAL( toggled(bool) ), this, TQ_SLOT( kcfg_UseBridges_toggled(bool) ) );
    connect( Bridge, TQ_SIGNAL( contextMenuRequested(TQListViewItem*,const TQPoint&,int) ), this, TQ_SLOT( Bridge_contextMenuRequested(TQListViewItem*,const TQPoint&,int) ) );
    connect( pushButton3, TQ_SIGNAL( clicked() ), this, TQ_SLOT( slotGetBridges() ) );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
FirewallsProxies::~FirewallsProxies()
{
    // no need to delete child widgets, TQt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void FirewallsProxies::languageChange()
{
    setCaption( tr2i18n( "MyDialog1" ) );
    kcfg_UseBridges->setText( tr2i18n( "My State or Service Provider Censors the Use of Tor" ) );
    pushButton3->setText( tr2i18n( "Fetch Listings" ) );
    textLabel1->setText( tr2i18n( "You can fetch a list of servers from http://bridges.torproject.org" ) );
    textLabel2->setText( tr2i18n( "You can also fetch listings by emailing bridges@torproject.org from a gmail or yahoo account." ) );
    BridgePanel->setTitle( tr2i18n( "Restrictive Firewall Avoidance" ) );
    pushBridgeAdd->setText( tr2i18n( "&Add" ) );
    FirewallLabel_2->setText( tr2i18n( "<p>Tor will only use the servers in the box to the right to communicate with the rest of the Tor network.</p>\n"
"<p>The servers are known as 'bridges'.</p>" ) );
    Bridge->header()->setLabel( 0, tr2i18n( "Address" ) );
    Bridge->header()->setLabel( 1, tr2i18n( "Port" ) );
    Bridge->header()->setLabel( 2, tr2i18n( "Key (Optional)" ) );
    tabWidget->changeTab( TabPage, tr2i18n( "Evade Censorship" ) );
    kcfg_FascistFirewall->setText( tr2i18n( "My Firewall Only Lets Certain Ports Out" ) );
    Proxies->setTitle( tr2i18n( "Proxies" ) );
    kcfg_HttpProxyAuthenticatorUserName->setInputMask( TQString::null );
    textLabel3_2->setText( tr2i18n( "Port:" ) );
    kcfg_HttpsProxyAuthenticatorPassword->setInputMask( TQString::null );
    textLabel2_4_3_2->setText( tr2i18n( "User Name:" ) );
    kcfg_HttpProxyAuthenticatorPassword->setInputMask( TQString::null );
    textLabel1_3->setText( tr2i18n( "<b>HTTPS Proxy</b>" ) );
    textLabel2_4_2_2_2->setText( tr2i18n( "Password:" ) );
    textLabel3_3_2->setText( tr2i18n( "Port:" ) );
    kcfg_HttpsProxyAuthenticatorUserName->setInputMask( TQString::null );
    textLabel2_3_2->setText( tr2i18n( "Address:" ) );
    textLabel2_4_2_3->setText( tr2i18n( "Password:" ) );
    kcfg_HttpProxyHost->setInputMask( TQString::null );
    textLabel2_2->setText( tr2i18n( "Address:" ) );
    textLabel2_4_4->setText( tr2i18n( "User Name:" ) );
    kcfg_UseProxy->setText( tr2i18n( "I Use a Proxy to Access the Internet" ) );
    Firewall->setTitle( tr2i18n( "Restrictive Firewall Avoidance" ) );
    FirewallLabel2->setText( tr2i18n( "Prevent firewall time-outs by sending something every" ) );
    ReachableAddresses->header()->setLabel( 0, tr2i18n( "Port" ) );
    kcfg_KeepalivePeriod->setSuffix( tr2i18n( " minutes" ) );
    kcfg_KeepalivePeriod->setSpecialValueText( TQString::null );
    pushAdd->setText( tr2i18n( "&Add" ) );
    FirewallLabel->setText( tr2i18n( "<p>Tor will only use the ports in the box to the right to communicate with the rest of the Tor network.</p>" ) );
    tabWidget->changeTab( Widget8, tr2i18n( "&Evade your firewall" ) );
}

/****************************************************************************
** FirewallsProxies meta object code from reading C++ file 'firewallsproxies.h'
**
** Created by: The TQt Meta Object Compiler version 26 (TQt 3.5.0)
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef TQT_NO_COMPAT
#include "firewallsproxies.h"
#include <ntqmetaobject.h>
#include <ntqapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.5.0. It"
#error "cannot be used with the include files from this version of TQt."
#error "(The moc has changed too much.)"
#endif

const char *FirewallsProxies::className() const
{
    return "FirewallsProxies";
}

TQMetaObject *FirewallsProxies::metaObj = 0;
static TQMetaObjectCleanUp cleanUp_FirewallsProxies( "FirewallsProxies", &FirewallsProxies::staticMetaObject );

#ifndef TQT_NO_TRANSLATION
TQString FirewallsProxies::tr( const char *s, const char *c )
{
    if ( tqApp )
	return tqApp->translate( "FirewallsProxies", s, c, TQApplication::DefaultCodec );
    else
	return TQString::fromLatin1( s );
}
#ifndef TQT_NO_TRANSLATION_UTF8
TQString FirewallsProxies::trUtf8( const char *s, const char *c )
{
    if ( tqApp )
	return tqApp->translate( "FirewallsProxies", s, c, TQApplication::UnicodeUTF8 );
    else
	return TQString::fromUtf8( s );
}
#endif // TQT_NO_TRANSLATION_UTF8

#endif // TQT_NO_TRANSLATION

TQMetaObject* FirewallsProxies::staticMetaObject()
{
    if ( metaObj ) {
	return metaObj;
}
#ifdef TQT_THREAD_SUPPORT
    if (tqt_sharedMetaObjectMutex) tqt_sharedMetaObjectMutex->lock();
    if ( metaObj ) {
	if (tqt_sharedMetaObjectMutex) tqt_sharedMetaObjectMutex->unlock();
	return metaObj;
    }
#endif // TQT_THREAD_SUPPORT
    TQMetaObject* parentObject = TQDialog::staticMetaObject();
    static const TQUMethod slot_0 = {"pushAdd_clicked", 0, 0 };
    static const TQUParameter param_slot_1[] = {
	{ 0, &static_QUType_ptr, "TQListViewItem", TQUParameter::In },
	{ "point", &static_QUType_varptr, "\x0e", TQUParameter::In },
	{ 0, &static_QUType_int, 0, TQUParameter::In }
    };
    static const TQUMethod slot_1 = {"ReachableAddresses_contextMenuRequested", 3, param_slot_1 };
    static const TQUMethod slot_2 = {"slotDeleteEntry", 0, 0 };
    static const TQUParameter param_slot_3[] = {
	{ "on", &static_QUType_bool, 0, TQUParameter::In }
    };
    static const TQUMethod slot_3 = {"kcfg_FascistFirewall_toggled", 1, param_slot_3 };
    static const TQUParameter param_slot_4[] = {
	{ "on", &static_QUType_bool, 0, TQUParameter::In }
    };
    static const TQUMethod slot_4 = {"kcfg_UseProxy_toggled", 1, param_slot_4 };
    static const TQUParameter param_slot_5[] = {
	{ "text", &static_QUType_TQString, 0, TQUParameter::In }
    };
    static const TQUMethod slot_5 = {"kcfg_HttpProxyHost_textChanged", 1, param_slot_5 };
    static const TQUParameter param_slot_6[] = {
	{ "text", &static_QUType_int, 0, TQUParameter::In }
    };
    static const TQUMethod slot_6 = {"kcfg_HttpProxyPort_valueChanged", 1, param_slot_6 };
    static const TQUParameter param_slot_7[] = {
	{ "text", &static_QUType_TQString, 0, TQUParameter::In }
    };
    static const TQUMethod slot_7 = {"kcfg_HttpProxyAuthenticatorUserName_textChanged", 1, param_slot_7 };
    static const TQUParameter param_slot_8[] = {
	{ "text", &static_QUType_TQString, 0, TQUParameter::In }
    };
    static const TQUMethod slot_8 = {"kcfg_HttpProxyAuthenticatorPassword_textChanged", 1, param_slot_8 };
    static const TQUMethod slot_9 = {"pushBridgeAdd_clicked", 0, 0 };
    static const TQUParameter param_slot_10[] = {
	{ "on", &static_QUType_bool, 0, TQUParameter::In }
    };
    static const TQUMethod slot_10 = {"kcfg_UseBridges_toggled", 1, param_slot_10 };
    static const TQUParameter param_slot_11[] = {
	{ 0, &static_QUType_ptr, "TQListViewItem", TQUParameter::In },
	{ "point", &static_QUType_varptr, "\x0e", TQUParameter::In },
	{ 0, &static_QUType_int, 0, TQUParameter::In }
    };
    static const TQUMethod slot_11 = {"Bridge_contextMenuRequested", 3, param_slot_11 };
    static const TQUMethod slot_12 = {"slotDeleteBridgesEntry", 0, 0 };
    static const TQUMethod slot_13 = {"slotGetBridges", 0, 0 };
    static const TQUMethod slot_14 = {"parseBridges", 0, 0 };
    static const TQUMethod slot_15 = {"languageChange", 0, 0 };
    static const TQMetaData slot_tbl[] = {
	{ "pushAdd_clicked()", &slot_0, TQMetaData::Public },
	{ "ReachableAddresses_contextMenuRequested(TQListViewItem*,const TQPoint&,int)", &slot_1, TQMetaData::Public },
	{ "slotDeleteEntry()", &slot_2, TQMetaData::Public },
	{ "kcfg_FascistFirewall_toggled(bool)", &slot_3, TQMetaData::Public },
	{ "kcfg_UseProxy_toggled(bool)", &slot_4, TQMetaData::Public },
	{ "kcfg_HttpProxyHost_textChanged(const TQString&)", &slot_5, TQMetaData::Public },
	{ "kcfg_HttpProxyPort_valueChanged(int)", &slot_6, TQMetaData::Public },
	{ "kcfg_HttpProxyAuthenticatorUserName_textChanged(const TQString&)", &slot_7, TQMetaData::Public },
	{ "kcfg_HttpProxyAuthenticatorPassword_textChanged(const TQString&)", &slot_8, TQMetaData::Public },
	{ "pushBridgeAdd_clicked()", &slot_9, TQMetaData::Public },
	{ "kcfg_UseBridges_toggled(bool)", &slot_10, TQMetaData::Public },
	{ "Bridge_contextMenuRequested(TQListViewItem*,const TQPoint&,int)", &slot_11, TQMetaData::Public },
	{ "slotDeleteBridgesEntry()", &slot_12, TQMetaData::Public },
	{ "slotGetBridges()", &slot_13, TQMetaData::Public },
	{ "parseBridges()", &slot_14, TQMetaData::Public },
	{ "languageChange()", &slot_15, TQMetaData::Protected }
    };
    static const TQUParameter param_signal_0[] = {
	{ 0, &static_QUType_bool, 0, TQUParameter::In }
    };
    static const TQUMethod signal_0 = {"uncensorSelected", 1, param_signal_0 };
    static const TQMetaData signal_tbl[] = {
	{ "uncensorSelected(bool)", &signal_0, TQMetaData::Public }
    };
    metaObj = TQMetaObject::new_metaobject(
	"FirewallsProxies", parentObject,
	slot_tbl, 16,
	signal_tbl, 1,
#ifndef TQT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // TQT_NO_PROPERTIES
	0, 0 );
    cleanUp_FirewallsProxies.setMetaObject( metaObj );
#ifdef TQT_THREAD_SUPPORT
    if (tqt_sharedMetaObjectMutex) tqt_sharedMetaObjectMutex->unlock();
#endif // TQT_THREAD_SUPPORT
    return metaObj;
}

void* FirewallsProxies::tqt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "FirewallsProxies" ) )
	return this;
    return TQDialog::tqt_cast( clname );
}

// TQ_SIGNAL uncensorSelected
void FirewallsProxies::uncensorSelected( bool t0 )
{
    activate_signal_bool( staticMetaObject()->signalOffset() + 0, t0 );
}

bool FirewallsProxies::tqt_invoke( int _id, TQUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: pushAdd_clicked(); break;
    case 1: ReachableAddresses_contextMenuRequested((TQListViewItem*)static_QUType_ptr.get(_o+1),(const TQPoint&)*((const TQPoint*)static_QUType_ptr.get(_o+2)),(int)static_QUType_int.get(_o+3)); break;
    case 2: slotDeleteEntry(); break;
    case 3: kcfg_FascistFirewall_toggled((bool)static_QUType_bool.get(_o+1)); break;
    case 4: kcfg_UseProxy_toggled((bool)static_QUType_bool.get(_o+1)); break;
    case 5: kcfg_HttpProxyHost_textChanged((const TQString&)static_QUType_TQString.get(_o+1)); break;
    case 6: kcfg_HttpProxyPort_valueChanged((int)static_QUType_int.get(_o+1)); break;
    case 7: kcfg_HttpProxyAuthenticatorUserName_textChanged((const TQString&)static_QUType_TQString.get(_o+1)); break;
    case 8: kcfg_HttpProxyAuthenticatorPassword_textChanged((const TQString&)static_QUType_TQString.get(_o+1)); break;
    case 9: pushBridgeAdd_clicked(); break;
    case 10: kcfg_UseBridges_toggled((bool)static_QUType_bool.get(_o+1)); break;
    case 11: Bridge_contextMenuRequested((TQListViewItem*)static_QUType_ptr.get(_o+1),(const TQPoint&)*((const TQPoint*)static_QUType_ptr.get(_o+2)),(int)static_QUType_int.get(_o+3)); break;
    case 12: slotDeleteBridgesEntry(); break;
    case 13: slotGetBridges(); break;
    case 14: parseBridges(); break;
    case 15: languageChange(); break;
    default:
	return TQDialog::tqt_invoke( _id, _o );
    }
    return TRUE;
}

bool FirewallsProxies::tqt_emit( int _id, TQUObject* _o )
{
    switch ( _id - staticMetaObject()->signalOffset() ) {
    case 0: uncensorSelected((bool)static_QUType_bool.get(_o+1)); break;
    default:
	return TQDialog::tqt_emit(_id,_o);
    }
    return TRUE;
}
#ifndef TQT_NO_PROPERTIES

bool FirewallsProxies::tqt_property( int id, int f, TQVariant* v)
{
    return TQDialog::tqt_property( id, f, v);
}

bool FirewallsProxies::tqt_static_property( TQObject* , int , int , TQVariant* ){ return FALSE; }
#endif // TQT_NO_PROPERTIES
